#pragma once

#include "Network.h"
#include <iostream>
#include <cstdlib>
#include "math.h"
#include <time.h>

using namespace std;
class Alignment
{
public:
	float **similarity;

	float EC, IC, NC;
	int CCCV,CCCE;

	int *alignment;
	int *comp;
	int maxComp;
	int maxDeg;
	bool reverse;
	Network network1;
	Network network2;
	Alignment( Network net1, Network net2 );
	Alignment(void);
	~Alignment(void);
	void align(double aa);
	void setSimilarities(int iteration, double bb, double cc);
	void improve(double aa);
	void SAalign(double aa, int n);
	void evaluate(void);
	int getCCCV(void);
	int getCCCE(void);
	float getEC(void);
	float getNC(void);
	float getIC(void);
	void outputEvaluation(string name);
	void outputAlignment(string name);
private:
	float computeSimilarity(int node1, int node2);
};
