#include "Network.h"

Network::Network(void)
{
}

Network::Network(char *nam)
{

	name = nam;
	cout << "----------------------------------------------------------"<< endl;
	cout << "Network: " << name << endl;
	cout << endl;

	string fileName = name;

//	fileName.append( ".tab" );

	MapInt2List mapNeighbor;

	ifstream networkFile(fileName.c_str());
	string line;

	numOfEdge = 0;
	maxDeg = 0;
	string token;


	int id1, id2;

	while (getline(networkFile, line))
	{
		istringstream tokenizer(line);
		string token;

		getline(tokenizer, token, '\t'); //notic '\t'

		mapName.insert(MapString2Int::value_type(token,(int)mapName.size()));

		id1 = mapName[ token ];
		mNames.insert(MapInt2Name::value_type(id1, token));
		list<int> neighbs1;
		mapNeighbor.insert(MapInt2List::value_type( id1, neighbs1));

		getline(tokenizer, token, '\t');//notic '\t'

		if(token.at(token.length()-1)==13)
		{
			token = token.substr(0,token.length()-1);
		}
		mapName.insert(MapString2Int::value_type(token,(int)mapName.size()));

		id2 = mapName[ token ];
		mNames.insert(MapInt2Name::value_type(id2, token));
		list<int> neighbs2;
		mapNeighbor.insert(MapInt2List::value_type( id2, neighbs2));

		mapNeighbor[ id1 ].push_front( id2 );
		mapNeighbor[ id2 ].push_front( id1 );

	}

	size = mapName.size();


	neighbor = new int*[size];
	deg = new int[size];
	self = new bool[size];
	for(int i=0; i<size; i++)
		self[ i ] = false;

	list<int> tempList;
	list<int>::iterator it;
	for(int i=0; i<size; i++)
	{


		tempList = mapNeighbor[ i ];
		tempList.sort();
		tempList.unique();


		deg[i] = tempList.size();
		neighbor[i] = new int[deg[i]];

		numOfEdge += deg[i];

		if(deg[i] > maxDeg)
			maxDeg = deg[i];
		int j;
		for(j=0,it=tempList.begin(); it!= tempList.end() ; it++, j++)
			neighbor[i][j] = *it;
	}

	numOfEdge = numOfEdge / 2;

	for(int i=0; i<size; i++)
		for(int j=0; j<deg[i]; j++)
		{
			int k;
			for( k = 0; k < deg[ neighbor[i][j] ]; k++ )
				if(neighbor[ neighbor[i][j] ][ k ] ==i)
					break;
			if( k == deg[neighbor[i][j]] )
			{
				cout << "Problem : " << j << " is not neighbor with " << i << endl;
				cin >> numOfEdge;
			}
		}




	cout << "Num of Nodes:    " << size << endl;
	cout << "Num of Edges:    " << numOfEdge << endl;
	cout << "Maximum Degree:  " << maxDeg << endl;
	cout << "----------------------------------------------------------"<< endl;
}



void Network::randomEdgeRemoval(int remNum)
{
	int counter;
	int inCounter;

	int temp;

	maxDeg = 0;

	srand ( (unsigned int)time(NULL) );

	bool *removedEdge = new bool[numOfEdge];

	for(int i=0; i<numOfEdge; i++)
	{
		removedEdge[i] = false;
	}

	for(int i=0; i<remNum; i++)
	{
		temp = rand() % numOfEdge;
		while( removedEdge[ temp ] )
			temp = rand() % numOfEdge;
		removedEdge[temp] = true;
	}


	int remCounter = 0;
	for( counter=0; counter<size; counter++)
	{
		inCounter = 0;
		int * node;
		node = new int[size];
		for(int k=0; k<deg[counter]; k++)
		{
			if(  counter < neighbor[counter][k])
			{
				if (!removedEdge[ remCounter ])
				{
						node[inCounter] = neighbor[counter][k];
						inCounter++;
				}
				else
				{
					for(int i=0; i<deg[ neighbor[counter][k] ]; i++)
						if(neighbor[ neighbor[counter][k] ][i] == counter)
							neighbor[ neighbor[counter][k] ][i] = -1;

				}
				remCounter++;
			}
			else if( counter > neighbor[counter][k] && neighbor[counter][k] >= 0 )
			{
				node[inCounter] = neighbor[counter][k];
				inCounter++;
			}

		}
		delete [] neighbor[counter];
		neighbor[counter] = new int[inCounter];
		deg[counter] = inCounter;

		if(deg[counter] > maxDeg)
			maxDeg = deg[counter];

		for(int i=0; i<inCounter; i++)
			neighbor[counter][i] = node[i];
		delete [] node;
	}
	numOfEdge -= remNum;
}

void Network::randomNodeRemoval(int remNum)
{
	int counter;
	int inCounter;

	int temp;

	maxDeg = 0;

	srand ( (unsigned int)time(NULL) );

	bool *removedNode = new bool[numOfEdge];
	int *renode = new int[size];

	for(int i=0; i<numOfEdge; i++)
	{
		removedNode[i] = false;
	}

	for(int i=0; i<remNum; i++)
	{
		temp = rand() % size;
		while( removedNode[ temp ])
			temp = rand() % size;
		removedNode[temp] = true;
	}


	int **neighbor1 = new int*[size - remNum];
	int *deg1 = new int[size - remNum];

	counter = 0;

	for(int j=0; j<size; j++)
	{
		if( removedNode[j] )
			continue;
		renode[j] = counter;
		counter++;
	}


	counter = 0;
	numOfEdge = 0;
	for(int j=0; j<size; j++)
	{
		if( removedNode[j] )
			continue;

		inCounter = 0;
		int * node;
		node = new int[size];
		for(int k=0; k<deg[j]; k++)
		{
			if( !removedNode[neighbor[j][k]] )
			{
				node[inCounter] = renode[neighbor[j][k]];
				inCounter++;
			}
		}
		neighbor1[counter] = new int[inCounter];
		deg1[counter] = inCounter;
		numOfEdge += inCounter;

		if(deg1[counter] > maxDeg)
			maxDeg = deg1[counter];

		for(int i=0; i<inCounter; i++)
			neighbor1[counter][i] = node[i];

		delete [] node;
		counter++;
	}
	size = size - remNum;
	delete [] *neighbor;
	delete [] deg;
	neighbor = neighbor1;
	deg = deg1;
	numOfEdge = numOfEdge / 2;
}



void Network::randomEdgeAddition(int addNum)
{

	int counter;
	int inCounter;

	int temp1 = 0;
	int temp2 = 0;

	maxDeg = 0;

	srand ( (unsigned int)time(NULL) );

	int *addedEdge1 = new int[2 * addNum];
	int *addedEdge2 = new int[2 * addNum];

	bool reRand;
	int j ;

	for(int i=0; i<addNum; i++)
	{
		reRand = true;
		while(reRand)
		{
			while(reRand)
			{
				temp1 = rand() % size;
				temp2 = rand() % size;
				reRand = false;

				if( temp1 == temp2 )
					reRand = true;

				for(int j=0; j<deg[ temp1 ]; j++)
					if(neighbor[ temp1 ][j] == temp2)
						reRand = true;
			}

			for( j=2*i-1; j>=0; j-- )
			{
				if( ( addedEdge1[j]>temp1 ) || ( addedEdge1[j]==temp1 && addedEdge2[j]>temp2 ) )
				{
					addedEdge1[j+1] = addedEdge1[j];
					addedEdge2[j+1] = addedEdge2[j];
				}
				else
				{
					if( addedEdge1[j]==temp1 && addedEdge2[j]==temp2 )
						reRand = true;
					break;
				}
			}
		}

		addedEdge1[j+1] = temp1;
		addedEdge2[j+1] = temp2;

		for( j=2*i; j>=0; j-- )
		{
			if( ( addedEdge1[j]>temp2 ) || ( addedEdge1[j]==temp2 && addedEdge2[j]>temp1 ) )
			{
				addedEdge1[j+1] = addedEdge1[j];
				addedEdge2[j+1] = addedEdge2[j];
			}
			else
				break;
		}

		addedEdge1[j+1] = temp2;
		addedEdge2[j+1] = temp1;
	}

	int **neighbor1 = new int*[size];
	int *deg1 = new int[size];

	counter = 0;

	numOfEdge = 0;
	int addCounter = 0;

	for(counter=0; counter<size; counter++)
	{
		inCounter = 0;
		int * node;
		node = new int[size];
		for(int k=0; k<deg[counter]; k++)
		{
			if( addedEdge1[addCounter] == counter && addedEdge2[addCounter] < neighbor[counter][k])
			{
				node[inCounter] = addedEdge2[addCounter];
				inCounter++;
				addCounter++;
			}
			node[inCounter] = neighbor[counter][k];
			inCounter++;
		}
		while(addedEdge1[addCounter] == counter)
		{
			node[inCounter] = addedEdge2[addCounter];
			inCounter++;
			addCounter++;
		}
		neighbor1[counter] = new int[inCounter];
		deg1[counter] = inCounter;
		numOfEdge += inCounter;

		if(deg1[counter] > maxDeg)
			maxDeg = deg1[counter];

		for(int i=0; i<inCounter; i++)
			neighbor1[counter][i] = node[i];
		delete [] node;
	}

	delete [] *neighbor;
	delete [] deg;
	neighbor = neighbor1;
	deg = deg1;
	numOfEdge = numOfEdge /2;
}




Network::~Network(void)
{

}
